%^^A ---- introduction
\section{Einleitung}

Dieses Paket dient dazu, manuelle Änderungsmarkierung zu ermöglichen.

Verbesserungsvorschläge, Gedanken oder Kritik sind willkommen.
Das Paket wird auf \emph{gitlab} gehalten, bitte gehen Sie zu

\url{http://edgesoft.de/projects/latex/changes/}

für Links zum Quellcodezugang, Fehler- und Featuretracker etc.
Wenn Sie mich direkt kontaktieren wollen, mailen Sie bitte an \href{mailto:ekleinod@edgesoft.de}{ekleinod@edgesoft.de}.
Bitte starten Sie Ihr Mail-Subject mit \texttt{[changes]}.

\begin{quote}
	Das changes-Paket dient zur manuellen Markierung von geändertem Text, insbesondere Einfügungen, Löschungen und Ersetzungen.
	Der geänderte Text wird farbig markiert und, bei gelöschtem Text, durchgestrichen.
	Zusätzlich kann Text hervorgehoben und/oder kommentiert werden.
	Das Paket ermöglicht die freie Definition von Autoren und deren zugeordneten Farben.
	Es erlaubt zusätzlich die Änderung des Änderungs-, Autor-, Hervorhebungs- und Kommentarmarkups.
\end{quote}

Ein kurzes Beispiel für Änderungsmarkierung:

\begin{quote}
	Das ist \added[id=EK, comment={fehlendes Wort}]{zugefügter} Text.
	In diesem Satz ersetze ich ein \replaced[id=EK]{gutes}{schlechtes} Wort.
	Und jetzt noch ein \deleted[id=EK]{schlechtes} Wort zum Löschen.
	Text kann auch \highlight[id=EK]{hervorgehoben} oder nur \comment[id=EK]{Aus Spaß!} kommentiert werden.
\end{quote}

Im gleichen Ordner wie dieses Handbuch befindet sich ein Ordner "`examples"', der eine reichhaltige Auswahl an Anwendungsbeispielen für das Paket und dessen Befehle enthält.
Bitte sehen Sie die Beispiele als Inspiration oder erste Fehlerlösungsquelle an.


%^^A ---- usage
\cleardoublepage
\section{Benutzung des \chpackage{changes}-Pakets}
\label{sec:usage}

In diesem Kapitel wird die Nutzung des \chpackage{changes}-Pakets beschrieben.
Dabei wird ein typischer Anwendungsfall geschildert.
Die ausführliche Beschreibung der Paketoptionen und neuen Befehle finden Sie nicht hier, sondern in \autoref{sec:ui}.

Ausgangslage ist ein Text, an dem Änderungen vorgenommen werden sollen.
Diese Änderungen sollen markiert werden, und zwar für jeden Autor einzeln.
Eine solche Änderungsmarkierung ist \zB von WYSIWYG-Textprogrammen wie \emph{LibreOffice}, \emph{OpenOffice} oder \emph{Word} bekannt.

Zu diesem Zweck wurde das \chpackage{changes}-Paket entwickelt.
Das Paket stellt Befehle zur Verfügung, um verschiedene Autoren zu definieren und Text als zugefügt, gelöscht oder geändert zu markieren.
Zusätzlich kann Text hervorgehoben oder kommentiert werden.
Um das Paket zu nutzen, sollten Sie folgende Schritte ausführen:

\begin{enumerate}
	\item \chpackage{changes}-Paket einbinden
	\item Autoren definieren
	\item Textänderungen markieren
	\item Text hervorheben und kommentieren
	\item Dokument mit \hologo{LaTeX} setzen
	\item Liste von Änderungen anzeigen lassen
	\item Markierungen entfernen
\end{enumerate}

\minisec{\chpackage{changes}-Paket einbinden}

Um die Änderungsverfolgung zu aktivieren, ist das \chpackage{changes}-Paket wie folgt einzubinden:

\chinline{usepackage_changes}

bzw.

\chinline{usepackage_options_changes}

Mit den verfügbaren Optionen bestimmen Sie hauptsächlich das Aussehen der Änderungsmarkierungen.
Sie können das Aussehen der Änderungsmarkierungen auch nach Einbinden des \chpackage{changes}-Pakets verändern.

Für Details lesen Sie bitte \autoref{sec:ui:options} und \autoref{sec:ui:customizingoutput}.

\minisec{Autoren definieren}

Das \chpackage{changes}-Paket stellt einen vordefinierten anonymen Autor zur Verfügung.
Wenn Sie jedoch die Änderungen per Autor\_in verfolgen wollen, müssen Sie die entsprechenden Autor\_innen definieren.
Dies geht wie folgt:

\chinline{definechangesauthor}

Über die ID werden der/die Autor\_in und die zugehörigen Textänderungen eindeutig identifiziert.
Optional können Sie einen Namen angeben und dem/der Autor\_in eine eigene Farbe zuweisen.

Für Details lesen Sie bitte \autoref{sec:ui:authormanagement}.

\minisec{Textänderungen markieren}

Jetzt ist alles vorbereitet, um den geänderten Text zu markieren.
Benutzen Sie bitte je nach Änderung die folgenden Befehle:

für neu zugefügten Text:

\chinline{added}

für gelöschten Text:

\chinline{deleted}

für geänderten Text:

\chinline{replaced}

Die Angabe von Autoren-ID und eines Kommentars ist optional.

Für Details lesen Sie bitte \autoref{sec:ui:changemanagement}.


\minisec{Text hervorheben und kommentieren}

Vielleicht möchten Sie noch Text hervorheben oder kommentieren?

Text hervorheben:

\chinline{highlight}

Text kommentieren:

\chinline{comment}

Die Angabe der Autoren-ID und des Kommentars für Hervorhebungen ist optional.

Für Details lesen Sie bitte \autoref{sec:ui:comment}.


\minisec{Dokument mit \hologo{LaTeX} setzen}

Nachdem Sie die Änderungen im \hologo{LaTeX}-Text markiert haben, können Sie sie im erzeugten Dokument sichtbar machen, indem Sie das Dokument ganz normal übersetzen.
Durch die Übersetzung wird der geänderte Text so markiert, wie Sie das mittels der Optionen bzw.\ speziellen Befehle eingestellt haben.

\minisec{Liste von Änderungen anzeigen lassen}

Sie können sich eine Liste der Änderungen ausgeben lassen.
Dies erfolgt mit dem Kommando:

\chinline{listofchanges}

Die Ausgabe ist gedacht als Analogon zur Liste von Tabellen oder Abbildungen.

Die Angabe des Stils ist optional, standardmäßig wird \choption{style=list} gewählt.
Um einen schnellen Überblick über Art und Anzahl der Änderungen abhängig von dem/der Autor\_in zu bekommen, verwenden Sie den Befehl mit der Option \choption{style=summary} oder \choption{style=compactsummary}.
Zeigen Sie nur bestimme Änderungstypen mit der \choption{show}-Option.

Bei jedem \hologo{LaTeX}-Lauf werden die Daten für diese Liste in eine Hilfsdatei geschrieben.
Beim nächsten \hologo{LaTeX}-Lauf werden dann diese Daten genutzt, um die Änderungsliste anzuzeigen.
Daher sind nach jeder Änderung zwei \hologo{LaTeX}-Läufe notwendig, um eine aktuelle Änderungsliste anzuzeigen.

Für Details lesen Sie bitte \autoref{sec:ui:overview}.

\minisec{Markierungen entfernen}

Oft ist es der Fall, dass die Änderungen eines Dokuments angenommen oder abgelehnt werden und nach diesem Prozess die Änderungsmarkierungen entfernt werden sollen.
Sie können die Ausgabe der Änderungsmarkierungen per Option beim Einbinden des \chpackage{changes}-Pakets unterdrücken:

\chinline{usepackage_final_changes}

Die Entfernung der Markierungen aus dem Quelltext müssen Sie von Hand vornehmen, dafür steht auch ein Script von Yvon Cui zur Verfügung.
Das Script liegt im Verzeichnis:

\chinline[, language=bash]{path_script}

Das Script entfernt alle Markierungen, indem die Änderungen angenommen oder abgelehnt werden.
Sie können die zu entfernenden Markierungen individuell im interaktiven Modus selektieren bzw.\ selektieren, indem Sie das Skript ohne Optionen starten.

Das Skript benötigt \emph{python3}.

Nutzen Sie das Skript wie folgt:

\chinputlisting{, language=bash}{userdoc/script_pymergechanges}

Starten Sie das Skript ohne Optionen und Dateien für eine kurze Hilfe:

\chinputlisting{, language=bash}{userdoc/script_pymergechanges_empty}

Bekannte Probleme:

\begin{itemize}
	\item entfernt nur Markierungen, die in einer Zeile stehen, Markierungen, die mehrere Zeilen umfassen, werden ignoriert
	\item Probleme mit vernesteten Kommandos
\end{itemize}



%^^A ---- limitations
\cleardoublepage
\section{Einschränkungen und Erweiterungsmöglichkeiten}
\label{sec:limitations}

Das \chpackage{changes}-Paket ist sorgfältig programmiert und getestet worden.
Dennoch kann es vorkommen, dass Fehler im Paket sind, dass die Benutzung problematisch ist oder dass eine Funktion fehlt, die Sie gerne hätten.
In diesem Fall gehen Sie bitte zu

\url{http://changes.sourceforge.net/}

Dort finden Sie Links, wie Fehler oder Verbesserungen gemeldet werden können, wie Tips für andere Nutzerinnen angegeben werden können oder wie Sie bei der Entwicklung des Pakets mithelfen können.

Sie können mir auch eine Mail schreiben an \href{mailto:ekleinod@edgesoft.de}{ekleinod@edgesoft.de}, in diesem Fall starten Sie bitte Ihr Mail-Subject mit \texttt{[changes]}.

Die Änderungsmarkierung von Text funktioniert recht gut, es können auch ganze Absätze markiert werden.
Die Markierung ist eingeschränkt oder nicht möglich für:

\begin{itemize}
	\item Abbildungen
	\item Tabellen
	\item Überschriften
	\item manche Kommandos
	\item mehrere Absätze (manchmal)
\end{itemize}


Sie können versuchen, solchen Text in eine eigene Datei auszulagern, und diese mit \texttt{input} einzubinden.
Manchmal hilft das, oft ist es einen Versuch wert.
Danke an Charly Arenz für diesen Tip.

Fußnoten oder Randnotizen werden in bestimmten Umgebungen, \zB Tabellen oder der \emph{tabbing}-Umgebung, nicht korrekt gesetzt.
Vermeiden Sie das Markup, wenn Sie diese Umgebungen benutzen.

Das Paket bietet Raum für Erweiterungen, die ich ich jedoch nicht selbst programmieren werde (weil mir Zeit und oft auch die Fähigkeit fehlt).
Ich liste hier einige Möglichkeiten auf, die aktuelle Liste finden Sie im Issue-Tracker auf \emph{gitlab}:

\begin{itemize}
	\item Auswahl der anzunehmenden/abzulehnenden Änderungen mit entsprechendem Löschen des Textes
	\item Markierung von mehreren Absätzen
	\item Markierung von Bildern und Tabellen
	\item automatische Markierung anhand von diff-Informationen (unter Berücksichtigung der Einschränkungen bzgl.\ Absätzen, Bildern, etc.)
	\item Übersetzung der sprachabhängigen Texte und der Nutzerdokumentation in andere Sprachen
\end{itemize}



%^^A ---- user interface
\cleardoublepage
\section{Die Benutzerschnittstelle des \chpackage{changes}-Pakets}
\label{sec:ui}

In diesem Kapitel wird die Nutzerschnittstelle des \chpackage{changes}-Pakets vorgestellt, \dh alle Optionen und Kommandos.
Jede Option bzw. jedes neue Kommando werden beschrieben.
Wenn Sie die Optionen und Kommandos im Beispiel sehen wollen, sehen Sie bitte in das Beispielverzeichnis unter

\chinline[, language=bash]{path_doc_examples}

Die Beispieldateien sind mit der benutzten Option bzw. dem benutzten Kommando benannt.

%^^A -- options
\subsection{Paketoptionen}
\label{sec:ui:options}

\chinline{usepackage_options_changes}

Die Paketoptionen bestimmen das Verhalten des Gesamtpakets, \dh aller Befehle.

Die folgenden Optionen sind definiert:

\localtableofcontents



\subsubsection{draft}

\chinline{usepackage_draft_changes}

Die \choption{draft}-Option bewirkt, dass alle Änderungen markiert werden.
Die Änderungsliste kann durch \chcommand{listofchanges} ausgegeben werden.
Diese Option ist automatisch voreingestellt.

Die Angabe von \choption{draft} in \chcommand{documentclass} wird vom \chpackage{changes}-Paket mitgenutzt.
Die lokale Angabe von \choption{final} überstimmt die Angabe von \choption{draft} in \chcommand{documentclass}.

\subsubsection{final}

\chinline{usepackage_final_changes}

Die \choption{final}-Option bewirkt, dass alle Änderungsmarkierungen ausgeblendet werden und nur noch der korrekte Text ausgegeben wird.
Die Änderungsliste wird ebenfalls unterdrückt.

Die Angabe von \choption{final} in \chcommand{documentclass} wird vom \chpackage{changes}-Paket mitgenutzt.
Die lokale Angabe von \choption{draft} überstimmt die Angabe von \choption{final} in \chcommand{documentclass}.

\subsubsection{markup}

\chinline{usepackage_markup_changes}

Die \choption{markup}-Option wählt ein vordefiniertes visuelles Markup für geänderten Text.
Das default-Markup wird gewählt, wenn die Option nicht gesetzt wird.
Das mit \choption{markup} gewählte Markup kann mit den spezielleren Optionen \choption{addedmarkup}, \choption{deletedmarkup}, \choption{commentmarkup} oder \choption{highlightmarkup} geändert werden.

Die folgenden Werte für \emph{markup} sind definiert:
\begin{description}
	\item [\choption{default}] default für zugefügten, gelöschten und hervorgehobenen Text sowie Kommentare (default)
	\item [\choption{underlined}] zugefügter Text wird unterstrichen, gewellt unterstrichen für Hervorhebungen, default für gelöschten Text sowie Kommentare
	\item [\choption{bfit}] fetter zugefügter Text, schräger gelöschter Text, default für hervorgehobenen Text sowie Kommentare
	\item [\choption{nocolor}] es werden keine Farben verwendet, zugefügter Text wird unterstrichen, gewellt unterstrichen für Hervorhebungen, default für gelöschten Text sowie Kommentare
\end{description}

\chexample{usepackage_markup_changes}

Wenn von farbigem zu nichtfarbigem Markup oder umgekehrt gewechselt wird und eine Hilfsdatei existiert werden einige Kompilierfehler angezeigt.
Über diese ist hinwegzuspringen, beim zweiten Durchlauf sollten die Fehler verschwunden sein.


\subsubsection{addedmarkup}

\chinline{usepackage_addedmarkup_changes}

Die \choption{addedmarkup}-Option wählt ein vordefiniertes visuelles Markup für zugefügten Text.
Das default-Markup wird gewählt, wenn die Option nicht gesetzt wird.
Die Option \choption{addedmarkup} überschreibt das mit \choption{markup} gewählte Markup.

Die folgenden Werte für \emph{addedmarkup} sind definiert:
\begin{description}
	\item [\choption{colored}] kein Textmarkup, nur farbige Kennzeichnung -- {\color{orange} Beispiel} (default)
	\item [\choption{uline}] unterstrichener Text -- \uline{Beispiel}
	\item [\choption{uuline}] doppelt unterstrichener Text -- \uuline{Beispiel}
	\item [\choption{uwave}] gewellt unterstrichener Text -- \uwave{Beispiel}
	\item [\choption{dashuline}] gestrichelt unterstrichener Text -- \dashuline{Beispiel}
	\item [\choption{dotuline}] gepunktet unterstrichener Text -- \dotuline{Beispiel}
	\item [\choption{bf}] fetter Text -- \textbf{Beispiel}
	\item [\choption{it}] italic Text -- \textit{Beispiel}
	\item [\choption{sl}] schräger Text -- \textsl{Beispiel}
	\item [\choption{em}] hervorgehobener Text -- \emph{Beispiel}
\end{description}

Die Ausgabe ersetzten Texts ist ein Kombination von zugefügtem und gelöschten Text, daher beeinflusst deren Layoutänderung auch das Layout ersetzen Texts.

\chexample{usepackage_addedmarkup_changes}


\subsubsection{deletedmarkup}

\chinline{usepackage_deletedmarkup_changes}

Die \choption{addedmarkup}-Option wählt ein vordefiniertes visuelles Markup für zugefügten Text.
Die \choption{deletedmarkup}-Option wählt analog ein vordefiniertes visuelles Markup für gelöschten Text.
Das default-Markup wird gewählt, wenn die Option nicht gesetzt wird.
Die Optionen \choption{addedmarkup} und \choption{deletedmarkup} überschreiben das mit \choption{markup} gewählte Markup.

Die folgenden Werte für \emph{addedmarkup} sind definiert:

\begin{description}
	\item [\choption{sout}] durchgestrichener Text -- \sout{Beispiel} (default)
	\item [\choption{xout}] schräg durchgestrichener Text -- \xout{Beispiel}
	\item [\choption{colored}] kein Textmarkup, nur farbige Kennzeichnung -- {\color{orange} Beispiel}
	\item [\choption{uline}] unterstrichener Text -- \uline{Beispiel}
	\item [\choption{uuline}] doppelt unterstrichener Text -- \uuline{Beispiel}
	\item [\choption{uwave}] gewellt unterstrichener Text -- \uwave{Beispiel}
	\item [\choption{dashuline}] gestrichelt unterstrichener Text -- \dashuline{Beispiel}
	\item [\choption{dotuline}] gepunktet unterstrichener Text -- \dotuline{Beispiel}
	\item [\choption{bf}] fetter Text -- \textbf{Beispiel}
	\item [\choption{it}] italic Text -- \textit{Beispiel}
	\item [\choption{sl}] schräger Text -- \textsl{Beispiel}
	\item [\choption{em}] hervorgehobener Text -- \emph{Beispiel}
\end{description}

Die Ausgabe ersetzten Texts ist ein Kombination von zugefügtem und gelöschten Text, daher beeinflusst deren Layoutänderung auch das Layout ersetzen Texts.

\chexample{usepackage_deletedmarkup_changes}


\subsubsection{highlightmarkup}

\chinline{usepackage_highlightmarkup_changes}

Die \choption{highlightmarkup}-Option wählt ein vordefiniertes visuelles Markup für hervorgehobenen Text.
Das default-Markup wird gewählt, wenn die Option nicht gesetzt wird.
Die Option \choption{highlightmarkup} überschreibt das mit \choption{markup} gewählte Markup.

Die folgenden Werte für \emph{highlightmarkup} sind definiert:

\begin{description}
	\item [\choption{background}] Hervorhebung durch Hintergrundfarbe -- \colorbox{orange!30}{Beispiel} (default)
	\item [\choption{uuline}] doppelt unterstrichener Text -- \uuline{Beispiel}
	\item [\choption{uwave}] gewellt unterstrichener Text -- \uwave{Beispiel}
\end{description}

\chexample{usepackage_highlightmarkup_changes}


\subsubsection{commentmarkup}

\chinline{usepackage_commentmarkup_changes}

Die \choption{commentmarkup}-Option wählt ein vordefiniertes visuelles Markup für Kommentare.
Das default-Markup wird gewählt, wenn die Option nicht gesetzt wird.
Die Option \choption{commentmarkup} überschreibt das mit \choption{markup} gewählte Markup.

Die folgenden Werte für \emph{commentmarkup} sind definiert:

\begin{description}
	\item [\choption{todo}] Kommentar als ToDo-Notiz, die nicht in der Liste der ToDos erscheint\todo{Beispielkommentar} (default)
	\item [\choption{margin}] Kommentar im Seitenrand\marginpar{Beispielkommentar}
	\item [\choption{footnote}] Kommentar als Fußnote\footnote{Beispielkommentar}
	\item [\choption{uwave}] gewellt unterstrichener Text -- \uwave{Beispielkommentar}
\end{description}

\chexample{usepackage_commentmarkup_changes}


\subsubsection{authormarkup}

\chinline{usepackage_authormarkup_changes}

Die \choption{authormarkup}-Option wählt ein vordefiniertes visuelles Markup für die Autor-Identifizierung.
Das default-Markup wird gewählt, wenn die Option nicht gesetzt wird.

Die folgenden Werte für \emph{authormarkup} sind definiert:

\begin{description}
	\item [\choption{superscript}] hochgestellter Text -- Text\textsuperscript{Autor} (default)
	\item [\choption{subscript}] tiefgestellter Text -- Text\textsubscript{Autor}
	\item [\choption{brackets}] Text in Klammern -- Text(Autor)
	\item [\choption{footnote}] Text in einer Fußnote -- Text\footnote{Autor}
	\item [\choption{none}] keine Autor-Identifizierung
\end{description}

\chexample{usepackage_authormarkup_changes}


\subsubsection{authormarkupposition}

\chinline{usepackage_authormarkupposition_changes}

Die \choption{authormarkupposition}-Option gibt an, wo die Autor-Identifizierung gesetzt wird.
Der default-Wert wird gewählt, wenn die Option nicht gesetzt wird.

Die folgenden Werte für \emph{authormarkupposition} sind definiert:

\begin{description}
	\item [\choption{right}] rechts vom Text -- Text\textsuperscript{Autor} (default)
	\item [\choption{left}] links vom Text -- \textsuperscript{Autor}Text
\end{description}

\chexample{usepackage_authormarkupposition_changes}


\subsubsection{authormarkuptext}

\chinline{usepackage_authormarkuptext_changes}

Die \choption{authormarkuptext}-Option gibt an, was für die Autor-Identifizierung genutzt wird.
Der default-Wert wird gewählt, wenn die Option nicht gesetzt wird.

Die folgenden Werte für \emph{authormarkuptext} sind definiert:

\begin{description}
	\item [\choption{id}] Autoren-ID -- Text\textsuperscript{ID} (default)
	\item [\choption{name}] Autorenname -- Text\textsuperscript{Autorenname}
\end{description}

\chexample{usepackage_authormarkuptext_changes}


\subsubsection{todonotes}

\chinline{usepackage_todonotes_changes}

Optionen für das \chpackage{todonotes}-Paket können als Parameter der \choption{todonotes}-Option angegeben werden.
Mehrere Optionen oder Angaben mit Sonderzeichen müssen in geschweifte Klammern gesetzt werden.

\chexample{usepackage_todonotes_changes}



\subsubsection{truncate}

\chinline{usepackage_truncate_changes}

Optionen für das \chpackage{truncate}-Paket können als Parameter der \choption{truncate}-Option angegeben werden.
Mehrere Optionen oder Angaben mit Sonderzeichen müssen in geschweifte Klammern gesetzt werden.

\chexample{usepackage_truncate_changes}



\subsubsection{ulem}

\chinline{usepackage_ulem_changes}

Optionen für das \chpackage{ulem}-Paket können als Parameter der \choption{ulem}-Option angegeben werden.
Mehrere Optionen oder Angaben mit Sonderzeichen müssen in geschweifte Klammern gesetzt werden.

\chexample{usepackage_ulem_changes}



\subsubsection{xcolor}

\chinline{usepackage_xcolor_changes}

Optionen für das \chpackage{xcolor}-Paket können als Parameter der \choption{xcolor}-Option angegeben werden.
Mehrere Optionen oder Angaben mit Sonderzeichen müssen in geschweifte Klammern gesetzt werden.

\chexample{usepackage_xcolor_changes}


%^^A ---- change management

\subsection{Änderungsmanagement}
\label{sec:ui:changemanagement}

\localtableofcontents

\chnewcmd{added}
\label{sec:ui:cmd:added}

\chinline{added}

Der Befehl \chcommand{added} markiert zugefügten Text.
Der neue Text wird in geschweiften Klammern übergeben.

Das optionale Argument enthält Key-Value-Paare für die Angabe von Autor-ID sowie eines Kommentars.
Die Autor-ID muss mit einer mit dem \chcommand{definechangesauthor}-Befehl definierten ID übereinstimmen.
Enthält der Kommentar Sonderzeichen oder Leerzeichen, ist er in geschweifte Klammern einzuschließen.

Wenn ein Kommentar angegeben wurde, wird das direkte Autormarkup am geänderten Text unterdrückt, da es im Kommentar erscheint.

\chexample{added}
\chresult{added}


\chnewcmd{deleted}

\chinline{deleted}

Der Befehl \chcommand{deleted} markiert gelöschten Text.
Der gelöschte Text wird in geschweiften Klammern übergeben.

Optionale Argumente: siehe \chcommand{added} (\autoref{sec:ui:cmd:added}).

\chexample{deleted}
\chresult{deleted}


\chnewcmd{replaced}

\chinline{replaced}

Der Befehl \chcommand{replaced} markiert geänderten Text.
Der neue sowie der alte Text werden in dieser Reihenfolge jeweils in geschweiften Klammern übergeben.

Optionale Argumente: siehe \chcommand{added} (\autoref{sec:ui:cmd:added}).

Die Ausgabe ersetzten Texts ist ein Kombination von zugefügtem und gelöschten Text, daher beeinflusst deren Layoutänderung auch das Layout ersetzen Texts.

\chexample{replaced}
\chresult{replaced}



%^^A -- Highlighting and Comments ------------------------------------------------------
\subsection{Hervorhebungen und Kommentare}
\label{sec:ui:comment}

\localtableofcontents

\chnewcmd{highlight}

\chinline{highlight}

Der Befehl \chcommand{highlight} markiert hervorgehobenen Text.
Der hervorzuhebende Text wird in geschweiften Klammern übergeben.

Optionale Argumente: siehe \chcommand{added} (\autoref{sec:ui:cmd:added}).

\chexample{highlight}
\chresult{highlight}


\chnewcmd{comment}

\chinline{comment}

Der Befehl \chcommand{comment} fügt dem Dokument einen Kommentar hinzu.
Der Kommentar wird als in geschweiften Klammern übergeben.

Der Befehl besitzt nur ein optionales Argument: ein Key-Value-Paar für die Angabe der Autor-ID.
Die Autor-ID muss mit einer mit dem \chcommand{definechangesauthor}-Befehl definierten ID übereinstimmen.

Die Kommentare werden durchnumeriert, die Nummer erscheint im Kommentar.

\chexample{comment}
\chresult{comment}






%^^A -- Overview of changes
\subsection{Änderungsübersicht}
\label{sec:ui:overview}


\chnewcmd{listofchanges}

\chinline{listofchanges}

Der Befehl \chcommand{listofchanges} gibt eine Liste oder Zusammenfassung der Änderungen aus.
Im ersten \hologo{LaTeX}-Lauf wird eine Hilfsdatei angelegt, deren Daten im zweiten Durchlauf eingebunden werden.
Für eine aktuelle Liste der Änderungen sind daher zwei \hologo{LaTeX}-Läufe notwendig.

Es können drei optionale Argumente angegeben werden:

\begin{description}
	\item[\choption{style}] Listenstil
	\item[\choption{title}] individueller Titel
	\item[\choption{show}] Änderungstypen
\end{description}

\paragraph{style}
Über das Argument \choption{style} können verschiedene Listenstile für die Anzeige ausgewählt werden.
Es sind folgende drei Stile definiert:

\begin{description}
	\item[\choption{list}] gibt die Änderungsliste wie ein Inhaltsverzeichnis aus (default)
	\item[\choption{summary}] gibt die Anzahl der Änderungen gruppiert nach Autor aus
	\item[\choption{compactsummary}] wie \choption{summary}, jedoch werden Änderungen mit Anzahl 0 nicht ausgegeben
\end{description}

\paragraph{title}
Mit dem Argument \choption{title} kann ein eigener Titel für die Änderungsliste angegeben werden.
Wenn Sie Sonderzeichen oder Leerzeichen im Titel benutzen wollen, klammern Sie den Titel geschweift ein.

\paragraph{show}
Das Argument \choption{show} gibt an, welche Änderungstypen in der Änderungsliste ausgegeben werden.
Sie können die Typen mit Hilfe des Zeichens \texttt{|} kombinieren.
Wenn Sie \zB alle neuen Texte und alle Löschungen anzeigen wollen, geben Sie \texttt{show=added|deleted} an.

Die folgenden Werte sind definiert:

\begin{description}
	\item[\choption{all}] alle Typen (default)
	\item[\choption{added}] nur neue Texte
	\item[\choption{deleted}] nur Löschungen
	\item[\choption{replaced}] nur Ersetzungen
	\item[\choption{highlight}] nur Hervorhebungen
	\item[\choption{comment}] nur Kommentare
\end{description}

\chexample{listofchanges}



%^^A ---- Author management

\subsection{Autorenverwaltung}
\label{sec:ui:authormanagement}

\chnewcmd{definechangesauthor}

\chinline{definechangesauthor}

Der Befehl \chcommand{definechangesauthor} definiert einen neuen Autor/eine neue Autorin für Änderungen.
Es muss eine eindeutige Autor-ID angegeben werden, die keine Sonder- oder Leerzeichen enthalten darf.

Optional kann eine Farbe und ein Name angegeben werden.
Wird keine Farbe angegeben, wird blau genutzt.

Der Name wird in der Änderungsliste sowie im Markup benutzt, im Markup jedoch nur, wenn die entsprechende Option gesetzt ist.

Das Paket definiert einen anonymen Autor vor, der ohne ID genutzt werden kann.

\chexample{definechangesauthor}


%^^A ---- Adaptation of the output
\subsection{Anpassung der Ausgabe}
\label{sec:ui:customizingoutput}

\localtableofcontents

\chnewcmd{setaddedmarkup}

\chinline{setaddedmarkup}

Der Befehl \chcommand{setaddedmarkup} legt fest, wie neuer Text ausgezeichnet wird.
Ohne andere Definition gilt, dass der Text farbig oder je nach Option \choption{markup} bzw.\ \choption{addedmarkup} erscheint.

Werte für die Definition:

\begin{itemize}
	\item beliebige \hologo{LaTeX}-Befehle
	\item neuer Text wird mit "`\#1"' genutzt
\end{itemize}

\chexample{setaddedmarkup}


\chnewcmd{setdeletedmarkup}

\chinline{setdeletedmarkup}

Der Befehl \chcommand{setdeletedmarkup} legt fest, wie gelöschter Text ausgezeichnet wird.
Ohne andere Definition gilt, dass der Text durchgestrichen wird oder je nach Option \choption{markup} bzw.\ \choption{deletedmarkup} erscheint.

Werte für die Definition:

\begin{itemize}
	\item beliebige \hologo{LaTeX}-Befehle
	\item gelöschter Text wird mit "`\#1"' genutzt
\end{itemize}

Die Ausgabe ersetzten Texts ist ein Kombination von zugefügtem und gelöschten Text, daher beeinflusst deren Layoutänderung auch das Layout ersetzen Texts.

\chexample{setdeletedmarkup}


\chnewcmd{sethighlightmarkup}

\chinline{sethighlightmarkup}

Der Befehl \chcommand{sethighlightmarkup} legt fest, wie hervorgehobene Texte gesetzt werden.
Ohne andere Definition gilt, dass die Hervorhebung über die Hintergrundfarbe erfolgt oder je nach Option \choption{markup} bzw.\ \choption{commentmarkup} erscheint.

Werte für die Definition:

\begin{itemize}
	\item beliebige \hologo{LaTeX}-Befehle
	\item hervorgehobener Text wird mit "`\#1"' genutzt
	\item \chpackage{ifthenelse} boolscher Test auf farbigen Text mit ``\chcommand{isColored}''
	\item Autorenfarbe wird mit ``authorcolor'' genutzt
\end{itemize}

\chexample{sethighlightmarkup}


\chnewcmd{setcommentmarkup}

\chinline{setcommentmarkup}

Der Befehl \chcommand{setcommentmarkup} legt fest, wie Kommentare gesetzt werden.
Ohne andere Definition gilt, dass Kommentare im Rand oder je nach Option \choption{markup} bzw.\ \choption{commentmarkup} erscheint.

Werte für die Definition:

\begin{itemize}
	\item beliebige \hologo{LaTeX}-Befehle
	\item Kommentar wird mit "`\#1"' genutzt
	\item Autor-ID wird mit ``\#2'' genutzt
	\item Autor-Ausgabe (ID oder Name) wird mit ``\#3'' genutzt
	\item \chpackage{ifthenelse} boolscher Test auf anonymen Autor Text mit ``\chcommand{isAnonymous}''
	\item \chpackage{ifthenelse} boolscher Test auf farbigen Text mit ``\chcommand{isColored}''
	\item Autorenfarbe wird mit ``authorcolor'' genutzt
	\item Kommentaranzahl wird mit ``authorcommentcount'' genutzt
\end{itemize}

\chexample{setcommentmarkup}


\chnewcmd{setauthormarkup}

\chinline{setauthormarkup}

Der Befehl \chcommand{setauthormarkup} legt fest, wie der Autortext im Text angezeigt wird.
Ohne andere Definition gilt, dass der Autor hochgestellt erscheint.

Werte für die Definition:

\begin{itemize}
	\item beliebige \hologo{LaTeX}-Befehle
	\item Autor-Ausgabe (ID oder Name) wird mit ``\#1'' genutzt
\end{itemize}

\chexample{setauthormarkup}


\chnewcmd{setauthormarkupposition}

\chinline{setauthormarkupposition}

Der Befehl \chcommand{setauthormarkupposition} legt fest, auf welcher Seite der Autor im Text angezeigt wird.
Ohne andere Definition gilt, dass der Autor rechts von den Änderungen erscheint.

Die folgenden Werte für \emph{authormarkupposition} sind definiert:

\begin{description}
	\item [\choption{right}] rechts vom Text -- Text\textsuperscript{Autor} (default)
	\item [\choption{left}] links vom Text -- \textsuperscript{Autor}Text
\end{description}

\chexample{setauthormarkupposition}


\chnewcmd{setauthormarkuptext}

\chinline{setauthormarkuptext}

Der Befehl \chcommand{setauthormarkuptext} legt fest, welche Information des Autors im Text angezeigt wird.
Ohne andere Definition gilt, dass die Autor-ID genutzt wird.

Die folgenden Werte für \emph{authormarkuptext} sind definiert:

\begin{description}
	\item [\choption{id}] Autoren-ID -- Text\textsuperscript{ID} (default)
	\item [\choption{name}] Autorenname -- Text\textsuperscript{Autorenname}
\end{description}

\chexample{setauthormarkuptext}



\chnewcmd{settruncatewidth}

\chinline{settruncatewidth}

Der Befehl \chcommand{settruncatewidth} legt die Breite der Textkürzung in der Änderungsliste fest.
Die Standardbreite ist \texttt{0.6}\chcommand{textwidth}.

\chexample{settruncatewidth}



\chnewcmd{setsummarywidth}

\chinline{setsummarywidth}

Der Befehl \chcommand{setsummarywidth} legt die Breite der Änderungsliste mit Stil \choption{summary} bzw.\ \choption{compactsummary} fest.
Die Standardbreite ist \texttt{0.3}\chcommand{textwidth}.

\chexample{setsummarywidth}



\chnewcmd{setsummarytowidth}

\chinline{setsummarytowidth}

Der Befehl \chcommand{setsummarytowidth} legt die Breite der Änderungsliste mit Stil \choption{summary} bzw.\ \choption{compactsummary} anhand der Breite des übergebenen Texts fest.

\chexample{setsummarytowidth}



\chnewcmd{setsocextension}

\chinline{setsocextension}

Der Befehl \chcommand{setsocextension} legt die Dateierweiterung der Hilfsdatei für die Änderungszusammenfassung (soc-Datei\footnote{%
	"`soc"' steht dabei für "`summary of changes"'.
}) fest.
Ohne andere Definition gilt das Suffix "`\texttt{soc}"'.

Im angegebenen Beispiel würde für "`\texttt{foo.tex}"' eine Hilfsdatei erzeugt werden, die "`\texttt{foo.changes}"' bzw.\ "`\texttt{foo.chg}"' statt des Standardnamens "`\texttt{foo.soc}"' hieße.

\chexample{setsocextension}

\chimportant{Nutzen Sie keine Standard-\hologo{LaTeX}-Dateierweiterungen wie "`toc"' oder "`loc"', da das den normalen \hologo{LaTeX}-Lauf stören würde.}


%^^A ---- packages
\subsection{Benötigte Pakete}
\label{sec:ui:packages}

Das \chpackage{changes}-Paket bindet bereits Pakete ein, die für die Funktion des Pakets notwendig sind.
Eine genauere Beschreibung der einzelnen Pakete ist in der Dokumentation der Pakete selbst zu finden.

Die folgenden Pakete sind zwingend notwendig und müssen für die Nutzung des \chpackage{changes}-Pakets installiert sein:
\begin{description}
	\item [xifthen] stellt eine verbesserte \texttt{if}-Abfrage sowie eine \texttt{while}-Schleife zur Verfügung
	\item [xkeyval] Eingabe von Optionen mit Werteübergabe
	\item [xstring] verbesserte Stringoperationen
\end{description}

Die folgenden Pakete sind manchmal notwendig und müssen installiert sein, wenn sie über die entsprechende Option genutzt werden:
\begin{description}
	\item [pdfcolmk] wird geladen, wenn farbiger Text genutzt wird (default Markup); löst das Problem farbigen Texts über Seitenumbrüche hinweg (bei pdflatex)
	\item [todonotes] wird geladen, wenn Kommentare als ToDo-Notizen gesetzt werden (default Markup)
	\item [ulem] wird geladen, wenn Text durchgestrichen oder ausge-x-t wird (default Markup)
	\item [xcolor] wird geladen, wenn farbiger Text genutzt wird (default Markup)
\end{description}


%^^A ---- Authors
\cleardoublepage
\section{Autorinnen und Autoren}
\label{sec:authors}

Am \chpackage{changes}-Paket haben mehrere Autorinnen und Autoren mitgewirkt.
Viele Probleme wurden in de.comp.text.tex gelöst oder deren Lösung durch Lösungsansätzen inspiriert.
Danke.

Die Autorinnen und Autoren sind in alphabetischer Reihenfolge:
\begin{itemize}
	\item Chiaradonna, Silvano
	\item Cui, Yvon
	\item Fischer, Ulrike
	\item Giovannini, Daniele
	\item Kleinod, Ekkart
	\item Mittelbach, Frank
	\item Voss, Herbert
	\item Wölfel, Philipp
	\item Wolter, Steve
\end{itemize}



%^^A ---- Versions
\cleardoublepage
\section{Versionen}
\label{sec:versions}

Für eine Liste der verfügbaren Versionen und deren Änderungen gehen Sie bitte zu

\url{https://gitlab.com/ekleinod/changes/blob/master/changelog.md}

Dort sind auch die bereits implementierten aber noch nicht veröffentlichten Änderungen verzeichnet.

Wenn Sie an geplanten, zukünftigen Änderungen interessiert sind, finden Sie diese unter

\url{https://gitlab.com/ekleinod/changes/milestones}


%^^A ---- copyright, license
\cleardoublepage
\section{Weitergabe, Copyright, Lizenz}

Copyright 2007-2019 Ekkart Kleinod (\href{mailto:ekleinod@edgesoft.de}{ekleinod@edgesoft.de})

Dieses Paket darf unter der "`\hologo{LaTeX} Project Public License"' Version~1.3 oder jeder späteren Version weitergegeben und/oder geändert werden.
Die neueste Version dieser Lizenz steht auf \url{http://www.latex-project.org/lppl.txt} Version~1.3 und spätere Versionen sind Teil aller \hologo{LaTeX}-Distributionen ab Version~2005/12/01.

Dieses Paket besitzt den Status "`maintained"' (verwaltet).
Der aktuelle Verwalter dieses Pakets ist Ekkart Kleinod.

Dieses Paket besteht aus den Dateien

\begin{tabbing}
	mm\=\kill
	\>\texttt{source/latex/changes/changes.drv}\\
	\>\texttt{source/latex/changes/changes.dtx}\\
	\>\texttt{source/latex/changes/changes.ins}\\
	\>\texttt{source/latex/changes/examples.dtx}\\
	\>\texttt{source/latex/changes/README}\\
	\>\texttt{source/latex/changes/userdoc/*.tex}\\

	\>\texttt{scripts/changes/delcmdchanges.bash}
\end{tabbing}


und den generierten Dateien

\begin{tabbing}
	mm\=\kill
	\>\texttt{doc/latex/changes/changes.english.pdf}\\
	\>\texttt{doc/latex/changes/changes.english.withcode.pdf}\\
	\>\texttt{doc/latex/changes/changes.ngerman.pdf}\\

	\>\texttt{doc/latex/changes/examples/changes.example.*.tex}\\
	\>\texttt{doc/latex/changes/examples/changes.example.*.pdf}\\

	\>\texttt{tex/latex/changes/changes.sty}
\end{tabbing}


%^^A end of user documentation
